import { displayOneOf } from '../utils'

const display =
  (x : string[]) => displayOneOf(x, ' or ')

describe('oneOf', () => {
  test('1', () => {
    expect(display([]))
      .toEqual('nothing')
  })

  test('2', () => {
    expect(display(['foo']))
      .toEqual('foo')
  })

  test('3', () => {
    expect(display(['foo', 'bar']))
      .toEqual('foo or bar')
  })

  test('4', () => {
    expect(display(['foo', 'bar', 'baz']))
      .toEqual('foo, bar or baz')
  })

  test('5', () => {
    expect(display(['foo', 'bar', 'baz', 'quux']))
      .toEqual('foo, bar, baz or quux')
  })
})
