export type Async = {}
export type Sync = { sync : true }

export default class Action<A> {
  val : A | Promise<A>;
  constructor(value : A | Promise<A>) {
    this.val = value
  }

  map<B>(f : (a : A) => B) : Action<B> {
    if (this.val instanceof Promise) {
      return new Action(this.val.then(f))
    }
    return new Action(f(this.val))
  }

  cont<B>(f : (a : A) => Action<B>) : Action<B> {
    if (this.val instanceof Promise) {
      return new Action(this.val.then(x => f(x).val))
    }
    return new Action(f(this.val).val)
  }

  static all<A>(values : Action<A>[]) : Action<A[]> {
    if (values.every(x => !(x.val instanceof Promise))) {
      return new Action(values.map(x => x.val as A))
    }
    return new Action(Promise.all(values.map(x => x.val)))
  }
}
