export type CNF<A> = A[][]

export const _true = []
export const _false : CNF<any> = [[]]

export function and<A>(x : CNF<A>, y : CNF<A>) {
  const result = x.concat(y)
  if (result.some(x => x.length === 0)) {
    return _false
  }
  return result
}

export function or<A>(x : CNF<A>, y : CNF<A>) : CNF<A> {
  const result : CNF<A> = []
  for (const a of x) {
    for (const b of y) {
      result.push([...a, ...b])
    }
  }
  return result
}

